Тёмный

Remove Duplicate Elements from Unsorted Array - Java Code 

Programming Tutorials
Подписаться 22 тыс.
Просмотров 107 тыс.
50% 1

Опубликовано:

 

26 окт 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 60   
@sureshnaidu3519
@sureshnaidu3519 4 года назад
Very nice approach and explained very well. Subscribed. Thank you
@ProgrammingTutorials1M
@ProgrammingTutorials1M 4 года назад
Thank you.
@chrisw9597
@chrisw9597 4 года назад
These videos are a godsend. I don't normally comment, but you deserve my appraisal. Thank you!
@ProgrammingTutorials1M
@ProgrammingTutorials1M 4 года назад
Thank you Christopher.
@jeetamitshah6194
@jeetamitshah6194 3 года назад
In the first approach, what about the remaining 2 positions in the array? You left them empty. The original array is of length 7 and new array with only unique elements has a length of 5, so what about the remaining 2 positions in the array? Java doesn't allow dynamic arrays so the length of the array is not changing .
@ranadheersannihith2362
@ranadheersannihith2362 4 года назад
In the first approach, every time the last element is getting added arr[j++]=arr[len-1], then if the last element is 5 and not 6 then 5 will again be added at the end and the output could be 1,2,4,5,5.
@ProgrammingTutorials1M
@ProgrammingTutorials1M 4 года назад
Hi Ranadheer, You missed that condition if (arr[i] != arr[i + 1]) { arr[j++] = arr[i]; } In this condition, Second last element is already compared with last element. So, in that case second last element won't be added. You can run the code and check the output.
@ranadheersannihith2362
@ranadheersannihith2362 4 года назад
@@ProgrammingTutorials1M I am not talking about second last. Consider 5 as the last element and there is no 6. Then last element 5 has to be added to our output and our output would be 1,2,4,5 and 5.
@bharathkoneru4008
@bharathkoneru4008 3 года назад
@@ranadheersannihith2362 no man, you got it wrong. arr = {1,2,4,4,5,5,5} 5 ! =5 is not satisfied till last element, so 5 will not be added to the array on iteration using for loop. {1,2,4} 5 only gets added when we add manually last element of array. arr = {1,2,4,5}
@maheshkumarb7729
@maheshkumarb7729 3 года назад
Hi All, I tried for this input -> int[] arr = {4,2,1,5,5,6,7,8,8,9}; Its removing the duplicate values but was not printing the last value i.e., 9 in this example. We need to use --> for (int i=0; i for (int i=0; i
@marcos.a8814
@marcos.a8814 2 года назад
Thank you so much!! for hashing and set the -1 must be removed, only keep it for the first code, which is great because I don't really understand why it needs to be -1
@simbagaming4847
@simbagaming4847 2 месяца назад
i was searching for this comment
@shreyaroy4773
@shreyaroy4773 3 года назад
Awesome approach sir! Searched a lot then found this video! Can you please say how to implement the 2nd and 3rd approaches in C++?
@ProgrammingTutorials1M
@ProgrammingTutorials1M 3 года назад
Hi Shreya, I know only java.
@shreyaroy4773
@shreyaroy4773 3 года назад
@@ProgrammingTutorials1M ok sir! Thank you!
@Rahul39920
@Rahul39920 3 года назад
With this approach the problem is with line no: 74. This will throw ArrayIndexOutOfBoundsException when the size of the array is 0. And it adds extra burden to handle last element of Array. We can certainly improve this.
@venkyvenky4261
@venkyvenky4261 2 года назад
But output is not in order You changed the order sir
@RajeevKumar-gk1qo
@RajeevKumar-gk1qo 4 года назад
Explained very well. You are great.
@ProgrammingTutorials1M
@ProgrammingTutorials1M 4 года назад
Thanks a lot
@SaiTeja-ym2er
@SaiTeja-ym2er 2 года назад
Very Good explanation.Thanks
@ProgrammingTutorials1M
@ProgrammingTutorials1M 2 года назад
You are welcome
@3lpme
@3lpme 2 месяца назад
Whats the old syntax for traversing set bcoz im more comfortable at it but forgot 😅
@abdulrahmanabdullahi1875
@abdulrahmanabdullahi1875 2 года назад
Why is the sorting important when trying to remove the duplicates from an array?
@V.LaxmanaVyaas
@V.LaxmanaVyaas 5 месяцев назад
Sir the output is in ordered one..not in unordered one sir
@swapniljadhav5461
@swapniljadhav5461 5 лет назад
Good approaches. Is it possible to remove duplicates from unsorted array without using any collection. For example in O(1) or O(log n) space complexity
@ProgrammingTutorials1M
@ProgrammingTutorials1M 5 лет назад
Hi Swapnil, O(1) and O(logn) might not be possible for unsorted array. You need to traverse complete array to figure out the duplicates.
@UnprivilegedDelhi
@UnprivilegedDelhi 3 года назад
what if we need to maintain the order of the array, how can we implement it without sorting the array?
@ProgrammingTutorials1M
@ProgrammingTutorials1M 3 года назад
You can do it by using set data structure.
@debayanroy6325
@debayanroy6325 Год назад
If you use LinkedHashSet instead of HashSet you can even retain the order.
@explorelife2418
@explorelife2418 5 лет назад
The code is amazing. Thank you so much. Subscribed 😊😊 Can you please tell how to find the non repeating elements in the array? i.e the elements which occur only once.
@ProgrammingTutorials1M
@ProgrammingTutorials1M 5 лет назад
Thanks for your comment. Here is the video link : ru-vid.com/video/%D0%B2%D0%B8%D0%B4%D0%B5%D0%BE-vx_snk6RQl0.html
@asifbasheerkhan2855
@asifbasheerkhan2855 2 года назад
we should you linkedhashset instead of simple hashset because order in not preserved .
@ProgrammingTutorials1M
@ProgrammingTutorials1M 2 года назад
If you want to preserve order then you can
@7smessi803
@7smessi803 Год назад
Awesome approch brother'❤️❤️❤️
@ProgrammingTutorials1M
@ProgrammingTutorials1M Год назад
Thanks ✌️
@sakhi_dikshit
@sakhi_dikshit 4 года назад
Thank you so much😇😇 please upload more videos 🙏
@ProgrammingTutorials1M
@ProgrammingTutorials1M 3 года назад
I will try my best
@ProgrammingTutorials1M
@ProgrammingTutorials1M 5 лет назад
Code link is present in the description box
@mohdamirquadri5796
@mohdamirquadri5796 4 года назад
Sir instead of void in method use type and return value beacause in every interview there ask this pattern ..
@ProgrammingTutorials1M
@ProgrammingTutorials1M 4 года назад
Yes, In my new videos i have implemented this approach. You can check it.
@sivaram9439
@sivaram9439 5 лет назад
is first method is exactly crt for all the testcases....???
@ProgrammingTutorials1M
@ProgrammingTutorials1M 5 лет назад
Yes
@sakhi_dikshit
@sakhi_dikshit 4 года назад
Please make video on hackerrank problems.
@bryanlozano8905
@bryanlozano8905 2 года назад
Can you use merge sort, and eject duplicates during merge routine? Or would all of those repeated shifts hurt the algorithm? I guess you can at least record the index of elements that are to be ejected during sorting.
@ProgrammingTutorials1M
@ProgrammingTutorials1M 2 года назад
But in this case the time complexity would be O(nlogn). There is a tradeoff between time and space here. Using extra space we can solve this problem in linear time.
@shubhambhosale8467
@shubhambhosale8467 3 года назад
make an empty set and insert all array value in that set it get sorted+remove duplicate as well thanks me later
@Baby_Boy_Mintu
@Baby_Boy_Mintu 3 года назад
Thanks sir
@ProgrammingTutorials1M
@ProgrammingTutorials1M 2 года назад
Welcome
@Tangoez
@Tangoez 4 года назад
Shabbaruoureyyyy shabana pureyyyy Heyyyyyyy shaburshaburaaa pureyyyyyyy
@alokkachhap4171
@alokkachhap4171 5 лет назад
-> what it is
@ProgrammingTutorials1M
@ProgrammingTutorials1M 5 лет назад
This is the lambda expression which is introduced in java 8.
@ArunKumar-ko8po
@ArunKumar-ko8po 3 года назад
thank you :)
@ProgrammingTutorials1M
@ProgrammingTutorials1M 3 года назад
You're welcome!
@reefmansour3630
@reefmansour3630 3 года назад
Thaaaaaaannnnnk you the j++ is a smart move !!! thanks
@ProgrammingTutorials1M
@ProgrammingTutorials1M 3 года назад
Please like and share with your friends.
@jhoanmateofrancovargas1405
@jhoanmateofrancovargas1405 4 года назад
gracias por el vídeo,fue fácil entenderte aunque no hablaras mi idioma xd
@ProgrammingTutorials1M
@ProgrammingTutorials1M 4 года назад
muchas gracias